#include <iostream>
#include <algorithm>
#include <queue>
#include <climits>
#include <cmath>

#include <sstream>

using namespace std;


double path[1005];
bool vis[1005];
double table[1005][1005];
double n,s,t;

struct d3{
	d3(){};
	d3(double xx, double yy, double zz){
		x = xx;
		y = yy;
		z = zz; 
	}
	double x,y,z;
};

d3 mapa[1005];

int sx,sy,sz,ex,ey,ez;
int ax,ay,az,bx,by,bz;

int main(){

	while(cin >> n >> s >> t){
		for(int i = 0; i < n; i++){
			path[i] = INT_MAX / 2;
			vis[i] = false;
		}
		
		for(int i = 0; i < n; i++)
			for(int j = 0; j < n; j++){
				table[i][j] = INT_MAX / 2;
				if(i == j)
					table[i][j] = 0;
			}
			
	
	
		int k = 2;
		cin >> sx >> sy>>sz>>ex>>ey>>ez;
		mapa[0].x = sx;
		mapa[0].y = sy;
		mapa[0].z = sz;
		
		mapa[1].x = ex;
		mapa[1].y = ey;
		mapa[1].z = ez;
		for(int i = 0; i < n; i++){
			cin >> ax >> ay>>az>>bx>>by>>bz;
			int a,b;
			a = b = -1;
			
			for(int j = 0; j < k; j++){
				if(mapa[j].x == ax && mapa[j].y == ay && mapa[j].z == az){
					a = j;
					break;
				}
			}
			for(int j = 0; j < k; j++){
				if(mapa[j].x == bx && mapa[j].y == by && mapa[j].z == bz){
					b = j;
					break;
				}
			}
			if(a == -1){
				mapa[k++] = d3(ax,ay,az);
				a = k-1;
				}
			if(b == -1){
				mapa[k++] = d3(bx,by,bz);
				b = k-1;
				}
			
			if(a == 0 || b == 0){
				table[a][b] = table[b][a] = sqrt(pow(mapa[a].x- mapa[b].x,2)+pow(mapa[a].y- mapa[b].y,2)+pow(mapa[a].z- mapa[b].z,2)) / s;
			}
			else{
				table[a][b] = table[b][a] = sqrt(pow(mapa[a].x- mapa[b].x,2)+pow(mapa[a].y- mapa[b].y,2)+pow(mapa[a].z- mapa[b].z,2)) / s;
				table[a][b] += acos((mapa[a].x*mapa[b].x + mapa[a].y*mapa[b].y + mapa[a].z*mapa[b].z) / 
				sqrt(mapa[a].x*mapa[a].x + mapa[a].y*mapa[a].y + mapa[a].z*mapa[a].z)*sqrt(mapa[b].x*mapa[b].x + mapa[b].y*mapa[b].y + mapa[b].z*mapa[b].z)
				) / M_PI * 180.0 / t;

			}
		}
			
			priority_queue<int> q;
			q.push(0);
			path[0] = 0;
			
			while(!q.empty()){
				k = q.top();
				q.pop();
				
				vis[k] = true;
				
				if(mapa[k].x == ex && mapa[k].y == ey && mapa[k].z == ez)
					break;
				
				for(int i = 0; i < n + 1; i++){
					if(!vis[k]){
						path[i] = min(path[i], table[k][i] + path[k]);
						q.push(i);
					}
					
				}
				
			}
			
			for(int i = 0; i < n + 1; i++)
				cout << path[i] << " ";
			cout << endl;
			
			cout << path[1] << endl;	
		}
	


return 0;
}
